<?php

declare(strict_types=1);

namespace Drupal\entity_display_route\Routing;

use Drupal\Core\Routing\EnhancerInterface;
use Drupal\Core\Routing\RouteObjectInterface;
use Symfony\Component\HttpFoundation\Request;

/**
 * Defines a route enhancer for custom view displays.
 */
final class RouteEnhancer implements EnhancerInterface {

  /**
   * {@inheritdoc}
   */
  public function enhance(array $defaults, Request $request) {
    $route = $defaults[RouteObjectInterface::ROUTE_OBJECT];
    if (!$route->hasDefault('_controller') && $route->hasDefault('_entity_view')) {
      $defaults['_controller'] = '\Drupal\entity_display_route\Controller\EntityViewController::view';
      return $defaults;
    }
    return $defaults;
  }

}
